Subject: bug#41755: feature/native-comp (master?): temacs crash in GC during mark phase

From: Pip Cet <[email-masked]>
Date: Sun, 7 Jun 2020 19:41:19 +0000

On Sun, Jun 7, 2020 at 7:26 PM Andrea Corallo <[email-masked]> wrote:
> I'm experiencing non reproducible GC related crashes building
> feature/native-comp.

Does it happen for non-optimized builds? Also, what symbol is at
Lisp_Object value 0xb4f0 (i.e. iQwhatever == 405)?

> Both back-traces I've got looks similar:
>
> #0  0x00000000004dfe4c in symbol_marked_p (s=0xb4f0) at pdumper.h:149
> #1  mark_object (arg=<optimized out>) at alloc.c:6731
> #2  0x0000000000552390 in traverse_intervals_noorder (tree=0xffffffffe070,
>     function=0x4e0fe0 <mark_interval_tree_1>, arg=0x0) at intervals.c:234
> #3  0x00000000004e0060 in mark_object (arg=<optimized out>) at alloc.c:6784
> #4  0x00000000004e08ec in mark_memory (end=<optimized out>, start=<optimized out>)
>     at alloc.c:4860
> #5  mark_stack (bottom=<optimized out>, end=end@entry=0xffffffff71d0 "")
>     at alloc.c:5071
> #6  0x000000000055fd48 in mark_one_thread (thread=0x903b80 <main_thread>)
>     at thread.c:630
> #7  mark_threads_callback (ignore=<optimized out>) at thread.c:661
> #8  0x00000000004e1238 in garbage_collect () at alloc.c:6101
> #9  0x00000000004ff874 in maybe_gc () at lisp.h:5090
> #10 eval_sub (form=form@entry=XIL(0xcefe63)) at eval.c:2243
> #11 0x0000000000500108 in Fwhile (args=<optimized out>) at eval.c:1013
> ...
> So far I was not able to reproduce on X86_64 (where I've rr).

Please let us know if you manage to.

> This may not be related to feature/native-comp but to one of the recent
> GC changes and the stack marking strategy.

Or to the live_*_p changes...